/*What to do:
	     -abecedni razeni map
	     -NOKIA ovladani (switch)
	     -PgUP,PgDown,Home,End v menu move

             -Krupikova fce na rotaci optimize build 18 (line 722-777)
*/

#include <conio.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dir.h>
#include <time.h>

#define CUF 11  	    // color unselected foreground
#define CUB 1   	    // color unselected background
#define CSF 15  	    // color selected foreground
#define CSB 3   	    // color selected background

#define MENU_X_POS 0        // X axis of menu (0=centre)
#define MENU_Y_POS 0        // Y axis of menu (0=centre)
#define POCET 100	    // pocet na pozadi behajicich znaku

#define MAXSIZE	80	    // maximal size of window
#define MAXPLAYERS 4
#define MAXSPEED 50	    // maximal speed of game
#define LON 20		    // maximalni delka jmena hrace

#define MENU_POSITION_ROUTINE  if(menu_x_axis==0) x=(80-size)/2;else x=menu_x_axis;  if(menu_y_axis==0) y=(50-sumitems)/2;else y=menu_y_axis;



char main_menu(char firsttimes);
void printmenu(char *items,char width,char x, char y,char first,char it_cnt,char cuf,char cub); //vykresli menu-bez ramecku- *items pointer na retezec s nabidkou
void center(char *string,char size, char x, char y,char filbackground);
char countitems(char *items); //spocita pocet polozek v menu
void frame(char *title,char x,char y,char width,char heigth,char cuf,char cub); //vykresli ramecek v menu
char getkey(char *key); //ceka na klavesu-v prubehu cekani vykresluje bodiky na pozadi-jednina mozna fce na cteni z klavesnice
void printitem(char *items,char itnum,char x,char y,char width,char fore,char back); //vykresli jednu polozku z menu.Pouzivam pri prekreslovani kurzoru v menu
void hidecursor(); //skryje kurzor
int  move(char *items,int sumitems,char x,char y,char width,char cuf,char cub,char csf,char csb,char deletemenu,int itnum,int maxonscr); //kompletni fce na pohyb v menu
void game_options_menu();  //
void players_menu();       //
void numplayers_menu();    //  jednotliva menu a podmenu
void mode_menu();          //
void key_setup();          //
void init_players();       //inicializace hracu..udelam i cteni z fajlu
void menuitem(char *items,char *string,char itnum); //returns in String name of one item of menu
void setkeys(char NuberOfPlayer); //menu pro nastaveni klaves
void names_menu();
void chngname(char player);
void colors_menu();
void save_settings();
void load_map();
void InitPole();
void DrawEmAll();
void ClearEmAll();
void MoveEmAll();
void box(char znak,char left,char top,char right, char bottom);
char test(char hrac,char klav);  //testuje duplicitu klaves v nastaveni
void speed_menu();
void chngclr(char hrac);
int  openmap(char *file,char *name,char *size);
void face_menu();
int  expon (int co, int naco);
char bit(unsigned char inbyte, char numbit);
void draw_logo();
void keyname(char nop,char key,char *string); //vraci nazev stisknute klavesy
char testname(char nop); //testuje duplicitu jmen hracu
void memerror();
void bodies_menu();
void fade(char znak,char left,char top,char right, char bottom);
void status();
void fall_line(int line_n, int y_size);
void fall1(int x_size, int y_size);
void char_edit(unsigned char znak,char *pamet);

float pole[POCET][5];

char mapfile[13]="MAP01.PMF",
     mapname[33],mapres[8],speed=20;

char menu_x_axis=MENU_X_POS,
     menu_y_axis=MENU_Y_POS;

struct player
	     {
	      char exist;   //jestli je hrac zapnuty nebo ne
	      char name[LON+1];
	      char face[8]; //bitova mapa fontu na xichtik
	      char body[8]; //bitova mapa fontu na telo
	      char color;
	      char key[4][2]; //klavesy v poradi Nahoru,dolu,doleva,doprava
	     } plrs[MAXPLAYERS];


/*
main()
{
 textmode(C4350);
 randomize();
 init_players();
 InitPole();
 main_menu(1);
 textmode(LASTMODE);
 clrscr();
 return 0;
}
*/

char main_menu(char firsttimes)
{
 struct REGPACK rg;
 char items[]={"Play !!,Game Options,Load Map,Key Setup,Hi-Score,Save Settings,Exit,"}; //Vypis menu. kazdou polozku oddeluje carka
 char x,y,size=20,sumitems=countitems(items); //ad countitems -spocita pocet polozek v menu, tedy vysku cele nabidky. ad size-nejdelsi polozka v menu, tedy sirka menu
 char ic,icbg;
			  //Tohle je vlajka		       //tohle je kurzor           //znak rotace
 unsigned char fonts[3*8]={255,207,179,189,141,179,191,255,     0,127,65,65,65,65,127,0,    126,209,147,181,189,153,195,126};

 MENU_POSITION_ROUTINE

 rg.r_ax = 0x1110;			/* DOS Service & Subfunction	*/
 rg.r_bx = 0 | (8<<8);			/* Bank & #bytes per char	*/
 rg.r_cx = 3;				/* #chars to redefine		*/
 rg.r_dx = 250;				/* First char to be redefined	*/
 rg.r_es = FP_SEG (fonts);		/* Font address segment 	*/
 rg.r_bp = FP_OFF (fonts);		/* Font address offset		*/
 intr (0x10, &rg);

 if (!firsttimes) fall1(80,50);

 draw_logo();

 while (1)
   {
    frame(" Main Menu ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    switch (move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0))
	   {
	    case 0: return 1;
	    case 1: game_options_menu(); break;
	    case 2: load_map();	    	 break;
	    case 3: key_setup();	 break;
	    case 4: 			 break;
	    case 5: save_settings();	 break;
	    case 6: return 0;
	   }
   }
}

void printmenu(char *items,char width,char x, char y,char first,char it_cnt,char cuf,char cub)
{
 int globcnt=0,cnt=0,menu_cnt=-1;
 char line=0,tmp[MAXSIZE]="";

 textcolor(cuf);
 textbackground(cub);

 while (items[globcnt]!=0)
       {
	while (items[globcnt]!=',')
	      {
	       tmp[cnt]=items[globcnt];
	       globcnt++;
	       cnt++;
	      }
	menu_cnt++;
	if (it_cnt>0 && menu_cnt-first>=it_cnt) break;
	tmp[cnt]=0;
	globcnt++;
	cnt=0;
	if (menu_cnt>=first)
	   {
	    center(tmp,width,x,y+line,1);
	    line++;
	   }
       }
}

void center(char *string,char size, char x, char y,char fillbck)
{
 char cnt;
 if (fillbck)
    {
     gotoxy(x,y);
     for (cnt=0; cnt<size; cnt++) cprintf (" ");
    }
 gotoxy(x+(size-strlen(string))/2,y);
 cprintf("%s",string);
}

char countitems(char *items)
{
 char cnt=0,vys=0;
 while (items[cnt]!=0)
       {
	if(items[cnt]==',')vys++;
	cnt++;
       }
 return vys;
}

void frame(char *title,char x,char y,char width,char heigth,char cuf,char cub)
{
 char cnt;

 textcolor(cuf);
 textbackground(cub);

 gotoxy(x,y);
 cprintf("");
 for (cnt=0;cnt<width;cnt++) cprintf("");

 gotoxy(x,y+heigth+1);
 cprintf("");
 for (cnt=0;cnt<width;cnt++) cprintf("");

 for (cnt=0;cnt<heigth;cnt++)
     {
      gotoxy(x,cnt+1+y);
      cprintf("");
      gotoxy(x+width+1,cnt+1+y);
      cprintf("");
     }

 gotoxy(x+width+1,y);
 cprintf("");
 gotoxy(x+width+1,y+heigth+1);
 cprintf("");

 center(title,width+1,x+1,y,0);

}

char getkey(char *key)
{
  hidecursor();

  while (!kbhit())
       {
	DrawEmAll();   //
	delay(15);     //  Vykreslovani beziciho pozadi
	ClearEmAll();  //  jina funkce na cteni z klavesnice nemuze byt pouzita
	MoveEmAll();   //  v zajmu zachovani pohybu pozadi
       }

 *key=getch();
 if (*key!=0) return 0;
    else
	{
	 *key=getch();
	 return 1;
	}
}

void printitem(char *items,char itnum,char x,char y,char width,char fore,char back)
{
 int globcnt=0,cnt=0;

 textcolor(fore);
 textbackground(back);

 char tmp[MAXSIZE]="";
 while (items[globcnt]!=0)
       {
	if (cnt==itnum) break;
	if(items[globcnt]==',') cnt++;
	globcnt++;
       }
 cnt=0;
 while (items[globcnt]!=',')
       {
	tmp[cnt]=items[globcnt];
	globcnt++;
	cnt++;
       }
 center(tmp,width,x,y,1);
}

void hidecursor()
{
 gotoxy(79,50);
 textcolor(0);
 textbackground(0); //Trapne ale vtipne..
 cprintf("\b");
}

int move(char *items,int sumitems,char x,char y,char width,char cuf,char cub,char csf,char csb,char dm,int itnum,int maxonscr)
{
 char key;
 int cnt,first=0,posi=itnum;
 float barpoint;
 status();
 if (maxonscr==0 || maxonscr>sumitems) maxonscr=sumitems;
  do
   {
    if (maxonscr<sumitems)
       {
	textcolor(cuf);
	textbackground(cub);

	gotoxy(x+width,y);
	cprintf("%c",30);

	gotoxy(x+width,y+maxonscr-1);
	cprintf("%c",31);

	for(cnt=y+1;cnt<y+maxonscr-1;cnt++)
	   {
	    gotoxy(x+width,cnt);
	    cprintf("%c",177);
	   }
	barpoint=((float)itnum/(float)sumitems)*(maxonscr-2)+y+1;
	gotoxy(x+width,barpoint);
	cprintf ("%c",219);
       }
    printitem(items,itnum,x,y+posi,width,csf,csb);
    if (getkey(&key)!=0)
       {
	printitem(items,itnum,x,y+posi,width,cuf,cub);
	switch (key)
	       {
		case 'H': {
			   if(posi>0)
			     {
			      posi--;
			      itnum--;
			     }
			     else
				 if(itnum>posi)
				   {
				    itnum--;
				    printmenu(items,width,x,y,--first,maxonscr,cuf,cub);
				   }
				 else if(maxonscr==sumitems) itnum=posi=sumitems-1;
									// if(maxonscr=0) itnum=sumitems-1;
			   break;
			  }

		case 'P': {
			   if(posi<maxonscr-1)
			     {
			      posi++;
			      itnum++;
			     }
			   else
			       if(itnum<sumitems-1)
				  {
				    itnum++;
				    printmenu(items,width,x,y,++first,maxonscr,cuf,cub);
				   }
			       else if(maxonscr==sumitems)itnum=posi=0;
			   break;
			  }
	       }
       }
   } while (key!=13 && key!=27);
// fall1(80,50);
// draw_logo();
 if (dm) box(255,x-1,y-1,x+width+2,y+sumitems+2); //Pri ukonceni smazeme ukoncene menu (pokud chcem) aby se na misto nej mohlo vykreslit jine
 if(key==27) return sumitems-1;
 return itnum;
}

void game_options_menu()
{
 char items[]={"Players,Mode,Speed,Return,"};
 char cntrl=1,x,y,size=20,sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 do
   {
    frame(" Game Options ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    switch (move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0))
	   {
	    case 0: players_menu(); break;
	    case 1: mode_menu();    break;
	    case 2: speed_menu();   break;
	    case 3: cntrl--;        break;
	   }
   }
 while (cntrl);
}

void players_menu()
{
 char items[]={"Number,Names,Colors,Faces,Bodies,Return,"};
 char cntrl=1,x,y,size=20,sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 do
   {
    frame(" Players ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    switch (move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0))
	   {
	    case 0: numplayers_menu();break;
	    case 1: names_menu();     break;
	    case 2: colors_menu();    break;
	    case 3: face_menu();      break;
	    case 4: bodies_menu();    break;
	    case 5: cntrl--; 	      break;
	   }
   }
 while (cntrl);
}

void mode_menu()
{
 char items[]={"Tunneler Mode,??,??,Return,"};
 char cntrl=1,x,y,size=20,sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 do
   {
    frame(" Mode ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    switch (move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0))
	   {
	    case 0:          break;
	    case 1:          break;
	    case 2:          break;
	    case 3: cntrl--; break;
	   }
   }
 while (cntrl);
}

void key_setup()
{
 char *items;
 char x,y,size=20,sumitems,len=0,cnt,choice,string[LON];

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	len+=strlen(plrs[cnt].name)+1; //ta jednicka je na carku ktera se pouziva v menu na oddeleni dalsi polozky
	len+=8; 		       //jese pridame jednu polozku, a to "RETURN," a jeste jeden byte na znak pro konec retezce 0x00
 if ((items=(char*)malloc(len)) == NULL) memerror();

 else
    for (cnt=0;cnt<len;cnt++) items[cnt]=0;

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	{
	 strcat(items,plrs[cnt].name);
	 strcat(items,",");
	}
 strcat(items,"Return,");

 sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 do
   {
    frame(" Key Setup ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0);

    if(choice!=sumitems-1)
	 {
	  menuitem(items,string,choice);
	  for (cnt=0;cnt<sumitems;cnt++)
	      if (strcmp(string,plrs[cnt].name)==0) break;
	  setkeys(cnt);
	 }
   }
 while (choice!=sumitems-1);
 free(items);
}

void init_players()
{
 FILE *f;
 char cyk,cnt=-1,ident[6]={0,0,0,0,0,0};
 struct REGPACK rg;

 f=fopen("players.psf","rb");  //otevri soubor s nastavenim

 if(f) fread(ident,5,1,f);

 if(!f || strcmp(ident,"PSF10"))			// jestlize neexistuje loadni defaultni nastaveni
   {
    plrs[0].exist=1;
    strcpy(plrs[0].name,"Player 1");
    plrs[0].color=11;
	plrs[0].face[0]=126;
	plrs[0].face[1]=255;
	plrs[0].face[2]=153;
	plrs[0].face[3]=255;
	plrs[0].face[4]=149;
	plrs[0].face[5]=203;
	plrs[0].face[6]=255;
	plrs[0].face[7]=126;
     plrs[0].body[0]=60;
     plrs[0].body[1]=66;
     plrs[0].body[2]=129;
     plrs[0].body[3]=129;
     plrs[0].body[4]=129;
     plrs[0].body[5]=129;
     plrs[0].body[6]=66;
     plrs[0].body[7]=60;
    plrs[0].key[0][0]=0;
    plrs[0].key[0][1]='H';
    plrs[0].key[1][0]=0;
    plrs[0].key[1][1]='P';
    plrs[0].key[2][0]=0;
    plrs[0].key[2][1]='K';
    plrs[0].key[3][0]=0;
    plrs[0].key[3][1]='M';

    plrs[1].exist=1;
    strcpy(plrs[1].name,"Player 2");
    plrs[1].color=10;
	plrs[1].face[0]=0;
	plrs[1].face[1]=60;
	plrs[1].face[2]=118;
	plrs[1].face[3]=31;
	plrs[1].face[4]=15;
	plrs[1].face[5]=31;
	plrs[1].face[6]=126;
	plrs[1].face[7]=60;
     plrs[1].body[0]=60;
     plrs[1].body[1]=66;
     plrs[1].body[2]=129;
     plrs[1].body[3]=129;
     plrs[1].body[4]=129;
     plrs[1].body[5]=129;
     plrs[1].body[6]=66;
     plrs[1].body[7]=60;
    plrs[1].key[0][0]='w';
    plrs[1].key[0][1]=0;
    plrs[1].key[1][0]='s';
    plrs[1].key[1][1]=0;
    plrs[1].key[2][0]='a';
    plrs[1].key[2][1]=0;
    plrs[1].key[3][0]='d';
    plrs[1].key[3][1]=0;

    plrs[2].exist=1;
    strcpy(plrs[2].name,"Player 3");
    plrs[2].color=12;
	plrs[2].face[0]=56;
	plrs[2].face[1]=84;
	plrs[2].face[2]=146;
	plrs[2].face[3]=146;
	plrs[2].face[4]=186;
	plrs[2].face[5]=108;
	plrs[2].face[6]=56;
	plrs[2].face[7]=0;
     plrs[2].body[0]=60;
     plrs[2].body[1]=66;
     plrs[2].body[2]=129;
     plrs[2].body[3]=129;
     plrs[2].body[4]=129;
     plrs[2].body[5]=129;
     plrs[2].body[6]=66;
     plrs[2].body[7]=60;
    plrs[2].key[0][0]='i';
    plrs[2].key[0][1]=0;
    plrs[2].key[1][0]='k';
    plrs[2].key[1][1]=0;
    plrs[2].key[2][0]='j';
    plrs[2].key[2][1]=0;
    plrs[2].key[3][0]='l';
    plrs[2].key[3][1]=0;

    plrs[3].exist=1;
    strcpy(plrs[3].name,"Player 4");
    plrs[3].color=13;
	plrs[3].face[0]=0;
	plrs[3].face[1]=64;
	plrs[3].face[2]=204;
	plrs[3].face[3]=126;
	plrs[3].face[4]=62;
	plrs[3].face[5]=20;
	plrs[3].face[6]=38;
	plrs[3].face[7]=32;
     plrs[3].body[0]=60;
     plrs[3].body[1]=66;
     plrs[3].body[2]=129;
     plrs[3].body[3]=129;
     plrs[3].body[4]=129;
     plrs[3].body[5]=129;
     plrs[3].body[6]=66;
     plrs[3].body[7]=60;
    plrs[3].key[0][0]='t';
    plrs[3].key[0][1]=0;
    plrs[3].key[1][0]='g';
    plrs[3].key[1][1]=0;
    plrs[3].key[2][0]='f';
    plrs[3].key[2][1]=0;
    plrs[3].key[3][0]='h';
    plrs[3].key[3][1]=0;
   }
 else
     for(cyk=0; cyk<MAXPLAYERS; cyk++)
	{
	 fread(&(plrs[cyk].exist),1,1,f);
	 do
	   {
	    cnt++;
	    fread(&(plrs[cyk].name[cnt]),1,1,f);
	   }while (plrs[cyk].name[cnt]);
	 fread(&(plrs[cyk].color),1,1,f);
	 fread(&(plrs[cyk].face),8,1,f);
	 fread(&(plrs[cyk].body),8,1,f);
	 fread(plrs[cyk].key,1,8,f); //misto 8 bylo 4
	 cnt=-1;
	}
 for(cyk=0; cyk<MAXPLAYERS; cyk++)
    {
     rg.r_ax = 0x1110;			/* DOS Service & Subfunction	*/
     rg.r_bx = 0 | (8<<8);		/* Bank & #bytes per char	*/
     rg.r_cx = 1;			/* #chars to redefine		*/
     rg.r_dx = 240+cyk; 		/* First char to be redefined	*/
     rg.r_es = FP_SEG (plrs[cyk].face);	/* Font address segment 	*/
     rg.r_bp = FP_OFF (plrs[cyk].face);	/* Font address offset		*/
     intr (0x10, &rg);
    }
 for(cyk=0; cyk<MAXPLAYERS; cyk++)
    {
     rg.r_ax = 0x1110;			/* DOS Service & Subfunction	*/
     rg.r_bx = 0 | (8<<8);		/* Bank & #bytes per char	*/
     rg.r_cx = 1;			/* #chars to redefine		*/
     rg.r_dx = 244+cyk; 		/* First char to be redefined	*/
     rg.r_es = FP_SEG (plrs[cyk].body);	/* Font address segment 	*/
     rg.r_bp = FP_OFF (plrs[cyk].body);	/* Font address offset		*/
     intr (0x10, &rg);
    }
 fread(&speed,1,1,f);
 fread(mapfile,13,1,f);
 fclose(f);
 openmap(mapfile,mapname,mapres);
}

void menuitem(char *items,char *string,char itnum) //vykresli jednu polozku na jeji urcene misto
{
 int globcnt=0,cnt=0;

 char tmp[MAXSIZE]="";
 while (items[globcnt]!=0)
       {
	if (cnt==itnum) break;
	if(items[globcnt]==',') cnt++;
	globcnt++;
       }
 cnt=0;
 while (items[globcnt]!=',')
       {
	tmp[cnt]=items[globcnt];
	globcnt++;
	cnt++;
       }
 strcpy(string,tmp);
}

void setkeys(char nop)
{
 char *items;
 char x,y,size=21,sumitems,cnt,choice,len=0,buf,klavname0[11],klavname1[11],klavname2[11],klavname3[11];

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	{
	 keyname(nop,cnt,klavname0);
	 len+=9+strlen(klavname0);
	}
 len+=27; 		       //dalsi polozky (Change all & return,RETURN)
 if ((items=(char*)malloc(len)) == NULL) memerror();
 else
    do
      {
       keyname(nop,0,klavname0);
       keyname(nop,1,klavname1);
       keyname(nop,2,klavname2);
       keyname(nop,3,klavname3);
       sprintf (items,"Up......%s,Down....%s,Left....%s,Right...%s,Change all & return,Return,",klavname0,klavname1,klavname2,klavname3);
       sumitems=countitems(items);

       MENU_POSITION_ROUTINE

       frame(" Keys Setting ",x,y,size,sumitems,CUF,CUB);
       printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
       choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,0,4,0);

       if (choice<sumitems-1)
	  {
	   printitem(items,choice,x+1,y+1+choice,size,CUF,CUB);
	   if (choice==sumitems-2)
	       {
		choice=0;
		len=4;
		for(cnt=0;cnt<4;cnt++)
		   {
		    plrs[nop].key[cnt][0]=0;  //kdyz se meni vsechny klavesy, smaye se jejich puvodni nastaveni-aby nevznikal konflikt s funkci TEST (treba kdyby nekdo misto nastaveni "ijkl" chtel "okl;")
		    plrs[nop].key[cnt][1]=0;
		    sprintf (items,"Up...... ,Down.... ,Left.... ,Right... ,Change all & return,Return,");
		    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
		   }
	       }
	   else len=1;

	   for(cnt=choice; cnt<choice+len;cnt++)
	      {
	       do
		 {
		  keyname(nop,0,klavname0);
		  keyname(nop,1,klavname1);
		  keyname(nop,2,klavname2);
		  keyname(nop,3,klavname3);
		  sprintf (items,"Up......%s,Down....%s,Left....%s,Right...%s,Change all & return,Return,",klavname0,klavname1,klavname2,klavname3);
		  printitem(items,cnt,x+1,y+1+cnt,size,CUF,CUB);
		  keyname(nop,cnt,klavname0);
		  gotoxy(x+(size+10-strlen(klavname0))/2,y+1+cnt);
		  textbackground(0);
		  textcolor(15+BLINK);
		  keyname(nop,cnt,klavname0);
		  cprintf("%s",klavname0);
		  if (getkey(&buf))
		     {
		      plrs[nop].key[cnt][0]=0;
		      plrs[nop].key[cnt][1]=buf;
		     }
		  else
		     {
		      plrs[nop].key[cnt][0]=buf;
		      plrs[nop].key[cnt][1]=0;
		     }
		 } while(test(nop,cnt));
	       keyname(nop,0,klavname0);
	       keyname(nop,1,klavname1);
	       keyname(nop,2,klavname2);
	       keyname(nop,3,klavname3);
	       sprintf (items,"Up......%s,Down....%s,Left....%s,Right...%s,Change all & return,Return,",klavname0,klavname1,klavname2,klavname3);
	       printitem(items,cnt,x+1,y+1+cnt,size,CUF,CUB);
	      }
	  }
       if (len==4)  //jestli byla zvolena polozka "change all & return" (len=4) vychazi z radku "if (choice==sumitems-2)" o 21 radku vyse
	  {
	   getkey(&len); //jen tak cekej na klavesu,jedno kam se nacte,nezajima me ta klavesa,jenom je to povinny parametr
	   choice=sumitems-1;
	  }
      }
    while (choice!=sumitems-1);
 free(items);
 box(255,x,y,x+size+2,y+sumitems+2); //Pri ukonceni smazeme stare menu
}



void InitPole()
{
 unsigned int count;

 for (count=0; count<POCET; count++)
     {
      pole[count][0]=random(16);
      pole[count][1]=random(80)+1;
      pole[count][2]=random(50)+1;
      pole[count][3]=(random(2)==1?-1:1)*(float(random(10.0)+1.0)/20.0);
      pole[count][4]=(random(2)==1?-1:1)*(float(random(10.0)+1.0)/20.0);
     }
}

void DrawEmAll()  //vykresli vsechny body na pozadi
{
 unsigned int count;
 unsigned char far *scr=(unsigned char far *)MK_FP(0xb800,0);

 for (count=0; count<POCET; count++)
     if(scr[((char)pole[count][2]-1)*80*2+((char)pole[count][1]-1)*2]==255)
       {
	scr[((char)pole[count][2]-1)*80*2+((char)pole[count][1]-1)*2+1]=(char)pole[count][0];
	scr[((char)pole[count][2]-1)*80*2+((char)pole[count][1]-1)*2]=254;
       }
}

void ClearEmAll() //zmaze vsechny body z pozadi
{
 unsigned int count;
 unsigned char far *scr=(unsigned char far *)MK_FP(0xb800,0);

 for (count=0; count<POCET; count++)
     {
      if(scr[((char)pole[count][2]-1)*80*2+((char)pole[count][1]-1)*2]>=254)
	 scr[((char)pole[count][2]-1)*80*2+((char)pole[count][1]-1)*2]=255;
     }
}

void MoveEmAll() //pohne se vsema bodama podle velikosti jejich vektoru-nevykresli je!!
{
 unsigned int count;

 for (count=0; count<POCET; count++)
     {
      pole[count][1]+=pole[count][3];
      pole[count][2]+=pole[count][4];

      if (pole[count][1]+pole[count][3]>80) pole[count][3]=-pole[count][3];
      if (pole[count][1]+pole[count][3]<1) pole[count][3]=-pole[count][3];

      if (pole[count][2]+pole[count][4]>50) pole[count][4]=-pole[count][4];
      if (pole[count][2]+pole[count][4]<1) pole[count][4]=-pole[count][4];
     }
}

void box(char znak,char l,char t,char r, char b)  //vyplni ctverec znaku (left,top.right,bottom)
{
 char x,y;
 unsigned char far *scr=(unsigned char far *)MK_FP(0xb800,0);

 for (x=l; x<r;x++)
     for (y=t; y<b;y++)
	 {
	  scr[(y-1)*80*2+(x-1)*2+1]=0;
	  scr[(y-1)*80*2+(x-1)*2]=znak;
	 }
}

void numplayers_menu()
{
 struct REGPACK rg;   //disabled		//enabled
 char signs[16]={0,34,54,28,28,54,34,0,  1,3,6,76,248,112,32};
 char *items;
 char x,y,size=26,sumitems,len=0,cnt,choice=0,bufr[6],ctr;

 rg.r_ax = 0x1110;			/* DOS Service & Subfunction	*/
 rg.r_bx = 0 | (8<<8);			/* Bank & #bytes per char	*/
 rg.r_cx = 2;				/* #chars to redefine		*/
 rg.r_dx = 252; 			/* First char to be redefined	*/
 rg.r_es = FP_SEG (signs);		/* Font address segment 	*/
 rg.r_bp = FP_OFF (signs);		/* Font address offset		*/
 intr (0x10, &rg);

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     len+=strlen(plrs[cnt].name)+3; // jeste pridame tento retezec:"," nebo ","
 len+=8; 		       	    //dalsi polozka (RETURN)

 if ((items=(char*)malloc(len)) == NULL) memerror();
 else
    {
     for (cnt=0;cnt<len;cnt++) items[cnt]=0;
     for (cnt=0;cnt<MAXPLAYERS;cnt++)
	 {
	  strcat(items,plrs[cnt].name);
	  sprintf(bufr," %c,",plrs[cnt].exist?'':'');
	  strcat(items,bufr);
	 }
     strcat(items,"Return,");
     sumitems=countitems(items);

     MENU_POSITION_ROUTINE

     frame(" Number ",x,y,size,sumitems,CUF,CUB);
     printmenu(items,size,x+1,y+1,0,0,CUF,CUB);

     do
       {
	choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,0,choice,0);

	if (choice!=sumitems-1)
	   {
	    plrs[choice].exist=plrs[choice].exist?0:1;

	    ctr=0;
	    for (cnt=0;cnt<len;cnt++)
		{
		 if(items[cnt]==',') ctr++;
		 if(ctr==choice+1)
		   {
		    items[cnt-1]=(items[cnt-1]==''?'':'');
		    break;
		   }
		}
	    printitem(items,choice,x+1,y+1+choice,size,CSF,CSB);
	   }
       } while (choice!=sumitems-1);
    }
 box(255,x,y,x+size+2,y+sumitems+2);
 free(items);
}

void names_menu()
{
 char *items;
 char x,y,size=20,sumitems,len=0,cnt,choice,string[LON];

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	len+=strlen(plrs[cnt].name)+1; //ta jednicka je na carku ktera se pouziva v menu na oddeleni dalsi polozky
 len+=8; 		       //jese pridame jednu polozku, a to "RETURN," a jeste jeden byte na znak pro konec retezce 0x00
 if ((items=(char*)malloc(len)) == NULL) memerror();
 else
    do
      {
       for (cnt=0;cnt<len;cnt++) items[cnt]=0;
       for (cnt=0;cnt<MAXPLAYERS;cnt++)
       if (plrs[cnt].exist)
	  {
	   strcat(items,plrs[cnt].name);
	   strcat(items,",");
	  }
       strcat(items,"Return,");

       sumitems=countitems(items);

       MENU_POSITION_ROUTINE

       frame(" Names ",x,y,size,sumitems,CUF,CUB);
       printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
       choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0);

       if(choice!=sumitems-1)
	 {
	  menuitem(items,string,choice);
	  for (cnt=0;cnt<sumitems;cnt++)
	      if (strcmp(string,plrs[cnt].name)==0) break;
	  chngname(cnt);
	 }
      }
    while (choice!=sumitems-1);
 free(items);
}

void chngname(char player)
{
 char x,y,cnt,chr;

 if (menu_x_axis==0) x=(80-LON)/2;
    else x=menu_x_axis;
 if (menu_y_axis==0) y=(49)/2;
    else y=menu_y_axis;

 for (cnt=0; cnt<LON+1; cnt++) plrs[player].name[cnt]=0;

 cnt=0;
 frame(" Enter new name: ",x,y,LON,1,CUF,CUB);

 do
   {
    do
      {
       getkey(&chr);
       textcolor(15);
       if (chr!=13 && chr!=8)
	  {
	   gotoxy(x+cnt+1,y+1);
	   cprintf("%c",chr);
	   plrs[player].name[cnt]=chr;
	   cnt++;
	  }
       if (chr==8 && cnt>0)
	  {
	   cnt--;
	   plrs[player].name[cnt]=0;
	   gotoxy(x+cnt+1,y+1);
	   cprintf("%c",255);
	  }
      }while(chr!=13 && cnt!=LON);
   }while (testname(player));
}

char test(char hrac,char klav)  //funkce testuje duplcitu nastaveni klaves mezi hraci
{
 char cnt_pl,cnt_key,cntr=0;

 for (cnt_pl=0;cnt_pl<MAXPLAYERS;cnt_pl++)
     for (cnt_key=0;cnt_key<4;cnt_key++)
	 if (plrs[cnt_pl].key[cnt_key][0]==plrs[hrac].key[klav][0] && plrs[cnt_pl].key[cnt_key][1]==plrs[hrac].key[klav][1]) cntr++;
 return cntr>1?1:0;
}

void colors_menu()
{
 char *items;
 char x,y,size=20,sumitems,len=0,cnt,choice,string[LON];

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	len+=strlen(plrs[cnt].name)+1; //ta jednicka je na carku ktera se pouziva v menu na oddeleni dalsi polozky
	len+=8; 		       //jese pridame jednu polozku, a to "RETURN," a jeste jeden byte na znak pro konec retezce 0x00
 if ((items=(char*)malloc(len)) == NULL) memerror();
 else
    for (cnt=0;cnt<len;cnt++) items[cnt]=0;

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	{
	 strcat(items,plrs[cnt].name);
	 strcat(items,",");
	}
 strcat(items,"Return,");

 sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 do
   {
    frame(" Colors ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0);

    if(choice!=sumitems-1)
	 {
	  menuitem(items,string,choice);
	  for (cnt=0;cnt<sumitems;cnt++)
	      if (strcmp(string,plrs[cnt].name)==0) break;
	  chngclr(cnt);
	 }
   }
 while (choice!=sumitems-1);
 free(items);
}

void save_settings()
{
 FILE *f;
 char cyk,cnt=-1;


 f=fopen("players.psf","wb");
 fwrite("PSF10",5,1,f);
 for(cyk=0; cyk<MAXPLAYERS; cyk++)
    {
     fwrite(&(plrs[cyk].exist),1,1,f);
     do
       {
	cnt++;
	fwrite(&(plrs[cyk].name[cnt]),1,1,f);
       }while (plrs[cyk].name[cnt]);
     fwrite(&(plrs[cyk].color),1,1,f);
     fwrite(&(plrs[cyk].face),8,1,f);
     fwrite(&(plrs[cyk].body),8,1,f);
     fwrite(plrs[cyk].key,1,8,f); //misto 8 bylo 4
     cnt=-1;
    }
 fwrite(&speed,1,1,f);
 fwrite(mapfile,13,1,f);
 fclose(f);
}

void load_map()
{
 struct ffblk fblk;
 char x,y,choice,key,done,size=42,bufr[33],res[8];
 int sumitems=1,cnt,len=7; //len ma 7 kvuli tomu co prijde jako posledni polozka (RETURN,)
 char *items;
 bufr[32]=0;

 if (menu_x_axis==0) x=(80-30)/2;
    else x=menu_x_axis;
 if (menu_y_axis==0) y=(50-4)/2;
    else y=menu_y_axis;

 frame(" Load Map ",x,y,30,4,CUF,CUB);
 textcolor(CUF);
 textbackground(CUB);
 gotoxy(x+1,y+1);
 cprintf("                              ");
 gotoxy(x+1,y+2);
 cprintf("         Please wait          ");
 gotoxy(x+1,y+3);
 cprintf(" while looking for map files  ");
 gotoxy(x+1,y+4);
 cprintf("                              ");

 done = findfirst("*.PMF",&fblk,0);
 while(!done)                        //spocteme si delku nazvu map (vsech souboru s maskou *.PMF) a jejich pocet
      {
       len+=1+32+10; //ta jednicka je zase na carku za polozkama a 32 je Max delka nazvu mapy a k tomu jeste rozliseni na 10 mist " (000x000)"
       sumitems++;
       done = findnext(&fblk);
      }

 if ((items=(char*)malloc(len)) == NULL) memerror();
 for (cnt=0;cnt<len;cnt++)
     items[cnt]=0;

 if (sumitems-1)
	 {
	  done=findfirst("*.PMF",&fblk,0);
	  while(!done)
	       {
		openmap(fblk.ff_name,bufr,res);
		strcat(items,bufr);
		sprintf(bufr," (%s),",res);
		strcat(items,bufr);
		done = findnext(&fblk);
	       }
	 }
 strcat(items,"Return,"); //a nakonec flakneme vraceni do GO menu (game options)

 box(255,x,y,x+32,y+6);

 if (menu_x_axis==0) x=(80-size)/2;
    else x=menu_x_axis;
 if (menu_y_axis==0) y=(50-(sumitems>20?20:sumitems))/2;
    else y=menu_y_axis;

 frame(" Load Map ",x,y,size,sumitems>20?20:sumitems,CUF,CUB);
 printmenu(items,size,x+1,y+1,0,20,CUF,CUB);
 choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,20);
 if(choice!=sumitems-1)
   {
    findfirst("*.PMF",&fblk,0);
    for (cnt=0;cnt<choice;cnt++)
	findnext(&fblk);
    strcpy(mapfile,fblk.ff_name);
   }
 free(items);
 openmap(mapfile,mapname,mapres);
}

void speed_menu()
{
 char x,y,key;

 if (menu_x_axis==0) x=(80-MAXSPEED+2)/2;
    else x=menu_x_axis;
 if (menu_y_axis==0) y=(50-2)/2;
    else y=menu_y_axis;

 frame(" Speed (moves per second)",x,y,MAXSPEED+2,2,CUF,CUB);
 gotoxy(x+1,y+2);
 cprintf ("%c%c",17,16);

 do
   {
    textcolor (CUF);
    textbackground (CUB);

    gotoxy(x+1,y+1);
 cprintf (" Slow                    %i                    Fast ",speed);

    gotoxy(x+1+speed,y+2);
    cprintf ("");

    getkey(&key);

    textcolor (CUF);
    textbackground (CUB);

    gotoxy(x+1+speed,y+2);
    cprintf ("");

    if (key=='M' && speed<MAXSPEED) speed++;
    if (key=='K' && speed>1) speed--;
   }
 while (key!=13 && key!=27);

 box(255,x,y,x+MAXSPEED+5,y+4);
}

void chngclr(char hrac)
{
 char items[]={"Black,Dark Blue,Dark Green,Dark Cyan,Dark Red,Dark Magenta,Orange,Light Grey,Dark Grey,Blue,Green,Cyan,Red,Magenta,Yellow,White,"};
 char x,y,size=16,sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 frame(" Change Color ",x,y,size,sumitems,CUF,CUB);
 printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
 plrs[hrac].color=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,plrs[hrac].color,0);
}

int openmap(char *file,char *name,char *size)
{
 FILE *fajl;
 char sign[4]={0,0,0,0},ver[3]={0,0,0};
 int xres=0,yres=0;

 if((fajl=fopen(file,"rb"))==NULL)
   {
    sprintf(name,"!! Disk error or no map file !!");
    sprintf(size,"???x???");
   }
 else
     {
      fread(sign,3,1,fajl);

      if(strcmp(sign,"PMF"))
	{
	 sprintf(name,"!! %s Corrupted !!",file);
	 sprintf(size,"???x???");
	 fclose(fajl);
	 return strlen(name);
	}
      fread(&ver,2,1,fajl);

      if(strcmp(ver,"10"))
	{
	 sprintf(name,"!! %s New version !!",file);
	 sprintf(size,"???x???");
	 fclose(fajl);
	 return strlen(name);
	}
      fread(name,32,1,fajl);
      fseek(fajl,1,SEEK_CUR);
      fread(&xres,1,1,fajl);
      fread(&yres,1,1,fajl);
      sprintf(size,"%ix%i",xres,yres);
      fclose(fajl);
      return strlen(name);
     }
 return 0;
}

void face_menu()
{
 char *items;
 char x,y,size=24,sumitems,len=0,cnt,choice,string[LON],bufr[24];

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	len+=strlen(plrs[cnt].name)+4; //jeste pridavame 4 znaky: ' '  xichtik  ','  0x000
	len+=8; 		       //jese pridame jednu polozku, a to "RETURN," a jeste jeden byte na znak pro konec retezce 0x00
 if ((items=(char*)malloc(len)) == NULL) memerror();
 else
    for (cnt=0;cnt<len;cnt++) items[cnt]=0;

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	{
	 strcat(items,plrs[cnt].name);
	 sprintf(bufr," %c,",240+cnt);
	 strcat(items,bufr);
	}
 strcat(items,"Return,");

 sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 do
   {
    frame(" Faces ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0);

    if(choice!=sumitems-1)
	 {
	  menuitem(items,string,choice);
	  for (cnt=0;cnt<sumitems;cnt++)
	      {
	       sprintf(bufr,"%s %c",plrs[cnt].name,240+cnt);
	       if (strcmp(string,bufr)==0) break;
	      }
	  char_edit(240+cnt,plrs[cnt].face);
	 }
   }
 while (choice!=sumitems-1);
 free(items);
}

int expon (int co, int naco)
{
 if (naco==0) return 1;

 char cnt;
 int vys=co;

 for (cnt=1; cnt<naco; cnt++) vys*=co;
 return vys;
}

char bit(unsigned char inbyte, char numbit)
{
 char cnt,out;
 unsigned temp=inbyte;

 for(cnt=7;cnt>=numbit;cnt--)
    {
     if(expon(2,cnt)<=temp)
       {
	out=1;
	temp-=expon(2,cnt);
       }
     else out=0;
    }
 return out;
}

void draw_logo()
{
 box(255,1,1,81,51);
 textbackground(1);
 textcolor(12);
 gotoxy(45,6);
 cprintf ("");

 gotoxy(1,8);
 cprintf("\n\r");
 cprintf("\n\r");
 cprintf("\n\r");
 cprintf("\n\r");
 cprintf("\n\r");
 cprintf("");
}

void keyname(char nop,char key,char *string)
{
 if(plrs[nop].key[key][0])
   {
    string[0]=plrs[nop].key[key][0];
    string[1]=0;
    switch(plrs[nop].key[key][0])
	  {
	   case   9:strcpy(string,"Tabulator"); break;
	   case  13:strcpy(string,"Enter"); 	break;
	   case  27:strcpy(string,"Escape"); 	break;
	   case ' ':strcpy(string,"Space"); 	break;
	  }

   }
 else
   {
    string[0]=plrs[nop].key[key][1];
    string[1]=0;
    switch(plrs[nop].key[key][1])
	  {
	   case 'H':strcpy(string,"Key UP"); 	break;
	   case 'P':strcpy(string,"Key DOWN"); 	break;
	   case 'K':strcpy(string,"Key LEFT"); 	break;
	   case 'M':strcpy(string,"Key RIGHT"); break;

	   case 'R':strcpy(string,"Insert"); 	break;
	   case 'S':strcpy(string,"Delete"); 	break;
	   case 'G':strcpy(string,"Home"); 	break;
	   case 'O':strcpy(string,"End"); 	break;
	   case 'I':strcpy(string,"Page UP"); 	break;
	   case 'Q':strcpy(string,"Page Down"); break;

	   case ';':strcpy(string,"F1"); 	break;
	   case '<':strcpy(string,"F2"); 	break;
	   case '=':strcpy(string,"F3"); 	break;
	   case '>':strcpy(string,"F4"); 	break;
	   case '?':strcpy(string,"F5"); 	break;
	   case '@':strcpy(string,"F6"); 	break;
	   case 'A':strcpy(string,"F7");	break;
	   case 'B':strcpy(string,"F8"); 	break;
	   case 'C':strcpy(string,"F9"); 	break;
	   case 'D':strcpy(string,"F10"); 	break;
	   case 133:strcpy(string,"F11"); 	break;
	   case 134:strcpy(string,"F12"); 	break;
	  }
   }
 if(plrs[nop].key[key][0]==0 && plrs[nop].key[key][1]==0)
   {
    string[0]=251;
    string[1]=0;
   }
}

char testname(char nop)
{
 char cnt;

 for (cnt=0; cnt<MAXPLAYERS; cnt++)
     {
      if (cnt==nop) cnt++;
      if (!strcmp(plrs[cnt].name,plrs[nop].name)) return 1;
     }
 return 0;
}

void memerror()
{
 textcolor(15);
 textbackground(0);
 gotoxy(1,1);
 cprintf ("Not enough memory for initializing menu.");
 exit(1);
}

void bodies_menu()
{
 char *items;
 char x,y,size=24,sumitems,len=0,cnt,choice,string[LON],bufr[24];

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	len+=strlen(plrs[cnt].name)+4; //jeste pridavame 4 znaky: ' '  xichtik  ','  0x000
	len+=8; 		       //jese pridame jednu polozku, a to "RETURN," a jeste jeden byte na znak pro konec retezce 0x00
 if ((items=(char*)malloc(len)) == NULL) memerror();
 else
    for (cnt=0;cnt<len;cnt++) items[cnt]=0;

 for (cnt=0;cnt<MAXPLAYERS;cnt++)
     if (plrs[cnt].exist)
	{
	 strcat(items,plrs[cnt].name);
	 sprintf(bufr," %c,",244+cnt);
	 strcat(items,bufr);
	}
 strcat(items,"Return,");

 sumitems=countitems(items);

 MENU_POSITION_ROUTINE

 do
   {
    frame(" Bodies ",x,y,size,sumitems,CUF,CUB);
    printmenu(items,size,x+1,y+1,0,0,CUF,CUB);
    choice=move(items,sumitems,x+1,y+1,size,CUF,CUB,CSF,CSB,1,0,0);

    if(choice!=sumitems-1)
	 {
	  menuitem(items,string,choice);
	  for (cnt=0;cnt<sumitems;cnt++)
	      {
	       sprintf(bufr,"%s %c",plrs[cnt].name,244+cnt);
	       if (strcmp(string,bufr)==0) break;
	      }
	  char_edit(244+cnt,plrs[cnt].body);
	 }
   }
 while (choice!=sumitems-1);
 free(items);
}


/*
void fade(char znak,char left,char top,char right, char bottom)
{
 unsigned int x,y;
 unsigned int cntr=0;
 unsigned char far *scr=(unsigned char far *)MK_FP(0xb800,0);

 while(cntr!=(right-left)*(bottom-top))
      {
       while(scr[y*80*2+x*2]==znak)
	    {
	     x=left+random(right);
	     y=top+random(bottom);
	    }
       scr[y*80*2+x*2+1]=0;
       scr[y*80*2+x*2]=znak;
       cntr++;
       if (cntr%20==0) delay(1);
      }
}
*/
void status()
{
 char keys[4][12],cyk,bufr[79];
 frame(" Current Settings ",1,42,78,6,CUF,0);

 textcolor(15);
 textbackground(0);
 gotoxy(2,43);
 cprintf("");
 sprintf(bufr,"Mapfile>\"%s\"%s  (%s)",mapname,mapres,mapfile);
 center(bufr,79,2,43,0);
 gotoxy(2,44);
 cprintf("");
 sprintf(bufr,"Speed>%imovespersecond",speed);
 center(bufr,79,2,44,0);

 for(cyk=0;cyk<MAXPLAYERS;cyk++)
    {
     keyname(cyk,0,keys[0]);
     keyname(cyk,1,keys[1]);
     keyname(cyk,2,keys[2]);
     keyname(cyk,3,keys[3]);
     textcolor(plrs[cyk].color);
     gotoxy(2,45+cyk);
     cprintf("");
     sprintf(bufr,"%s%s%c%c%s%s%s%s",plrs[cyk].name,plrs[cyk].exist?"Enabled":"Disabled",240+cyk,244+cyk,keys[0],keys[1],keys[2],keys[3]);
     center(bufr,79,2,45+cyk,0);
    }
}

void fall_line(int line_n, int y_size)
{
  int i1,i2,i3;
  unsigned char far *scr1=(unsigned char far *)MK_FP(0xb800,0);

  for (i1=y_size; i1>1; i1--)
  {
	scr1[(i1-1)*80*2+(line_n-1)*2]=scr1[(i1-2)*80*2+(line_n-1)*2];
	scr1[(i1-1)*80*2+(line_n-1)*2+1]=scr1[(i1-2)*80*2+(line_n-1)*2+1];
  }
  scr1[(line_n-1)*2]=0;
  scr1[(line_n-1)*2+1]=7;
}

void fall1(int x_size, int y_size)
{
  int i1,i2;
  unsigned char sl[100];
  double cpt=0; //cycles per tick pozedji konvertnuty na cycles per milisecond
  double tmr=0; //pocitadlo
  double temp=0;
  clock_t start;

  start=clock();		//
  while ((clock()-start)<1);    // pockame si az zacne novy tik hodin

  start=clock();		  //kvuli tomu abysme merili od zacatku tiku
  while ((temp-start)<1)
	{
	 temp=clock();
	 cpt++; //takze vysledek je kolik cyklu stihne pocitac za jeden hodinovy tik (54.95 milisekund (1/18.2)sec)
	}
  cpt=(CLK_TCK/1000)*cpt;

  for (i1=0; i1<x_size; i1++) sl[i1]=0;

  for (i1=0; i1<(x_size*y_size); i1++)
  {
	hidecursor();
	while (cpt/10>tmr) //cekame 1/5 milisekundy
	      {
	       temp=clock(); //tohle je tu kvuli tomu aby si ty casy ktere byly namereny odpovidaly. ta fce clock tam ubiji cas tak jako kdyz jsme ho merili
	       tmr++;
	      }
	tmr=0;

	i2=random(x_size);

	while (sl[i2]>(y_size-1)) i2=random(x_size);

	if(sl[i2]<y_size)
	  {
	   fall_line((i2+1), y_size);
	   sl[i2]++;
	  }

	i2++;
	if (i2>(x_size-1)) i2=0;
  }
}

void char_edit (unsigned char znak,char *pamet)
{
 struct REGPACK rg;
 char x,y,cnt1,cnt2,temp,key,curx=0,cury=0,field[8];

 if (menu_x_axis==0) x=(80-8)/2; //30
    else x=menu_x_axis;
 if (menu_y_axis==0) y=(50-8)/2; //22
    else y=menu_y_axis;

 frame(" Char ",x,y,8,8,CUF,CUB);
 frame("",x+10,y+3,1,1,CUF,CUB);
 gotoxy(x+11,y+4);
 cprintf("%c",znak);

 textcolor(7);
 textbackground(0);
 gotoxy(x+1,y+1);

 for(cnt1=0;cnt1<8;cnt1++)
    {
     for(cnt2=0;cnt2<8;cnt2++)
	cprintf ("%c",bit(pamet[cnt1],7-cnt2)?219:255);
     gotoxy(x+1,y+cnt1+2);
    }
 do
   {
    gotoxy(curx+x+1,cury+y+1);
    if (bit(pamet[cury],7-curx))
       {
	textcolor(BLINK);
	textbackground(15);
       }
    else
       {
	textcolor(7+BLINK);
	textbackground(0);
       }

    cprintf ("%c",251);
    if (getkey(&key)!=0)
       {
	gotoxy(curx+x+1,cury+y+1);
	textcolor(7);

	cprintf ("%c",bit(pamet[cury],7-curx)?219:255);
	switch(key)
	      {
	       case 'H': if (cury>0) cury--; else cury=7; break;
	       case 'P': if (cury<7) cury++; else cury=0; break;
	       case 'K': if (curx>0) curx--; else curx=7; break;
	       case 'M': if (curx<7) curx++; else curx=0; break;
	      }
       }
    if(key==32)
      {
       if(bit(pamet[cury],7-curx)) pamet[cury]-=expon(2,7-curx);
	 else pamet[cury]+=expon(2,7-curx);
       rg.r_ax = 0x1110;		/* DOS Service & Subfunction	*/
       rg.r_bx = 0 | (8<<8);		/* Bank & #bytes per char	*/
       rg.r_cx = 1;			/* #chars to redefine		*/
       rg.r_dx = znak; 			/* First char to be redefined	*/
       rg.r_es = FP_SEG (pamet);	/* Font address segment 	*/
       rg.r_bp = FP_OFF (pamet);	/* Font address offset		*/
       intr (0x10, &rg);
      }

   }while (key!=27 && key!=13);
 box(255,x,y,x+13,y+10);
}